#define GL_GLEXT_PROTOTYPES

#include <QtWidgets>
#include "glwidget.h"

GLWidget::GLWidget()
    : QGLWidget(QGLFormat(QGL::SampleBuffers ), 0)
{
}

GLWidget::~GLWidget()
{
}

bool GLWidget::loadColormap(const QString &fileName)
{
    QImage image;
	int x;

	if (!image.load(fileName)) return 0;

	for(x=0; x < 256; x++) colormap[x] = image.pixel(x, 0);
	glEnable(GL_TEXTURE_1D);
    glBindTexture(GL_TEXTURE_1D, texTF);
	glTexImage1D(GL_TEXTURE_1D, 0, GL_RGB, 256, 0, GL_BGRA,
            GL_UNSIGNED_INT_8_8_8_8_REV, colormap);
    glBindTexture(GL_TEXTURE_1D, 0);
	glDisable(GL_TEXTURE_1D);

	return 1;
}

void GLWidget::setVelocityScale(float min, float max) {minU = min; maxU = max;}
void GLWidget::setDensityScale(float min, float max) {minRho = min; maxRho = max;}

void GLWidget::setShader(int index) {currentShader = index;}
