#ifndef GLWIDGET_H
#define GLWIDGET_H

#include <QGLWidget>
#include <QtOpenGL>
#include "simulation.h"

class GLWidget : public QGLWidget
{
    Q_OBJECT

public:
    GLWidget();
    ~GLWidget();

    virtual void clipX(int pos, bool dir) = 0;
    virtual void clipY(int pos, bool dir) = 0;
    virtual void clipZ(int pos, bool dir) = 0;

    bool loadColormap(const QString &fileName);
    void setVelocityScale(float min, float max);
    void setDensityScale(float min, float max);

    void setShader(int index);

protected:
    unsigned int colormap[256];

    float minU, maxU, minRho, maxRho;

    Cursor *cursor;

    GLuint *pbo;     			// OpenGL pixel buffer object
    GLuint texData, texTF;    // textures

    int currentShader;
    QVector<QGLShaderProgram *> shaderPrograms;
    QVector<QGLShader *> fragmentShaders;
};

#endif
