#ifndef GLWIDGET_2D_H
#define GLWIDGET_2D_H

#include <QGLWidget>
#include <QtOpenGL>
#include "glwidget.h"
#include "simulation.h"

class GLWidget2D: public GLWidget
{
    Q_OBJECT

public:
    GLWidget2D(Simulation *sim = 0);
    ~GLWidget2D();

    QSize minimumSizeHint() const;
    QSize sizeHint() const;

    void clipX(int pos, bool dir);
    void clipY(int pos, bool dir);
    void clipZ(int pos, bool dir);

protected:
    void initializeGL();
    void paintGL();
    void resizeGL(int width, int height);

private:
    GLuint *pbo;     // OpenGL pixel buffer object
    GLuint texid;   // texture
    int width;
    int height;
    int deviceCount;
    Simulation *simulation;
};

#endif
